---
- name: Copy .env.staging
  copy:
    src: .env.staging
    dest: .env
  tags:
    - configuration
    - staging

- name: Build containers
  shell: docker-compose -f m-devops/docker-compose.yml -f m-devops/docker-stack.yml build
  tags:
    - build
    - staging

- name: Check that front, api and prisma images are built
  shell: docker images registry.gitlab.com/mickael.bourgois/m-devops/staging/* --format "{{ '{{' }} .Repository {{ '}}' }}"
  register: check_images
  tags:
    - verification
    - staging

- fail:
    msg: Missing images front, api or prisma, error in building them
  when: item not in check_images.stdout_lines
  loop:
    - registry.gitlab.com/mickael.bourgois/m-devops/staging/front
    - registry.gitlab.com/mickael.bourgois/m-devops/staging/api
    - registry.gitlab.com/mickael.bourgois/m-devops/staging/prisma
  tags:
    - verification
    - staging

- name: Login into gitlab container registry
  docker_login:
    registry: registry.gitlab.com
    username: "{{ gitlab_username }}"
    password: "{{ gitlab_password }}"
  tags:
    - gitlab
    - staging

- name: Push images to registry
  docker_image:
    name: "{{ item }}"
    push: yes
    source: local
  loop:
    - registry.gitlab.com/mickael.bourgois/m-devops/staging/front
    - registry.gitlab.com/mickael.bourgois/m-devops/staging/api
    - registry.gitlab.com/mickael.bourgois/m-devops/staging/prisma
  tags:
    - gitlab
    - staging
